using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;
using System.Diagnostics;

namespace Polygon
{
	public class FormMain : System.Windows.Forms.Form
	{
		double newX;	// the actual x value
		double newY;	// the actual y value
		int index;		// the actual index ( point number )
		Plot plot;		// plot object

		Polygon polygon;

		// to do: add reference to figure object

		#region Designer variables
		private System.Windows.Forms.GroupBox grpBoxPoint;
		private System.Windows.Forms.Label lblX;
		private System.Windows.Forms.TextBox editX;
		private System.Windows.Forms.TextBox editY;
		private System.Windows.Forms.Label lblY;
		private System.Windows.Forms.Button btnUpdate;
		private System.Windows.Forms.ColumnHeader colNr;
		private System.Windows.Forms.ColumnHeader colX;
		private System.Windows.Forms.ColumnHeader colY;
		private System.Windows.Forms.Label textArea;
		private System.Windows.Forms.Label textLength;
		private System.Windows.Forms.ListView listView;
		private System.Windows.Forms.Panel panel;
		private System.Windows.Forms.Button btnMove;
		private System.Windows.Forms.Button btnZoom;
		private System.ComponentModel.Container components = null;
		#endregion

		public FormMain()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.grpBoxPoint = new System.Windows.Forms.GroupBox();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.btnMove = new System.Windows.Forms.Button();
			this.editY = new System.Windows.Forms.TextBox();
			this.lblY = new System.Windows.Forms.Label();
			this.editX = new System.Windows.Forms.TextBox();
			this.lblX = new System.Windows.Forms.Label();
			this.listView = new System.Windows.Forms.ListView();
			this.colNr = new System.Windows.Forms.ColumnHeader();
			this.colX = new System.Windows.Forms.ColumnHeader();
			this.colY = new System.Windows.Forms.ColumnHeader();
			this.textArea = new System.Windows.Forms.Label();
			this.textLength = new System.Windows.Forms.Label();
			this.panel = new System.Windows.Forms.Panel();
			this.btnZoom = new System.Windows.Forms.Button();
			this.grpBoxPoint.SuspendLayout();
			this.SuspendLayout();
			// 
			// grpBoxPoint
			// 
			this.grpBoxPoint.Controls.Add(this.btnUpdate);
			this.grpBoxPoint.Controls.Add(this.btnMove);
			this.grpBoxPoint.Controls.Add(this.editY);
			this.grpBoxPoint.Controls.Add(this.lblY);
			this.grpBoxPoint.Controls.Add(this.editX);
			this.grpBoxPoint.Controls.Add(this.lblX);
			this.grpBoxPoint.Controls.Add(this.btnZoom);
			this.grpBoxPoint.Location = new System.Drawing.Point(4, 156);
			this.grpBoxPoint.Name = "grpBoxPoint";
			this.grpBoxPoint.Size = new System.Drawing.Size(160, 116);
			this.grpBoxPoint.TabIndex = 0;
			this.grpBoxPoint.TabStop = false;
			this.grpBoxPoint.Text = "Point / Figure";
			// 
			// btnUpdate
			// 
			this.btnUpdate.Location = new System.Drawing.Point(8, 52);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.Size = new System.Drawing.Size(60, 24);
			this.btnUpdate.TabIndex = 9;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// btnMove
			// 
			this.btnMove.Location = new System.Drawing.Point(8, 84);
			this.btnMove.Name = "btnMove";
			this.btnMove.Size = new System.Drawing.Size(60, 24);
			this.btnMove.TabIndex = 7;
			this.btnMove.Text = "Move";
			// 
			// editY
			// 
			this.editY.Location = new System.Drawing.Point(100, 20);
			this.editY.Name = "editY";
			this.editY.Size = new System.Drawing.Size(48, 20);
			this.editY.TabIndex = 6;
			this.editY.Text = "0";
			this.editY.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editY.Validating += new System.ComponentModel.CancelEventHandler(this.editY_Validating);
			// 
			// lblY
			// 
			this.lblY.Location = new System.Drawing.Point(80, 20);
			this.lblY.Name = "lblY";
			this.lblY.Size = new System.Drawing.Size(16, 20);
			this.lblY.TabIndex = 5;
			this.lblY.Text = "y :";
			this.lblY.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editX
			// 
			this.editX.Location = new System.Drawing.Point(24, 20);
			this.editX.Name = "editX";
			this.editX.Size = new System.Drawing.Size(48, 20);
			this.editX.TabIndex = 4;
			this.editX.Text = "0";
			this.editX.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editX.Validating += new System.ComponentModel.CancelEventHandler(this.editX_Validating);
			// 
			// lblX
			// 
			this.lblX.Location = new System.Drawing.Point(8, 20);
			this.lblX.Name = "lblX";
			this.lblX.Size = new System.Drawing.Size(16, 20);
			this.lblX.TabIndex = 3;
			this.lblX.Text = "x :";
			this.lblX.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// listView
			// 
			this.listView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																											  this.colNr,
																											  this.colX,
																											  this.colY});
			this.listView.FullRowSelect = true;
			this.listView.GridLines = true;
			this.listView.HideSelection = false;
			this.listView.Location = new System.Drawing.Point(8, 10);
			this.listView.MultiSelect = false;
			this.listView.Name = "listView";
			this.listView.Size = new System.Drawing.Size(152, 78);
			this.listView.TabIndex = 1;
			this.listView.View = System.Windows.Forms.View.Details;
			this.listView.SelectedIndexChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
			// 
			// colNr
			// 
			this.colNr.Text = "Nr.";
			this.colNr.Width = 28;
			// 
			// colX
			// 
			this.colX.Text = "X";
			this.colX.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// colY
			// 
			this.colY.Text = "Y";
			this.colY.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// textArea
			// 
			this.textArea.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.textArea.Location = new System.Drawing.Point(8, 128);
			this.textArea.Name = "textArea";
			this.textArea.Size = new System.Drawing.Size(152, 20);
			this.textArea.TabIndex = 24;
			this.textArea.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// textLength
			// 
			this.textLength.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.textLength.Location = new System.Drawing.Point(8, 104);
			this.textLength.Name = "textLength";
			this.textLength.Size = new System.Drawing.Size(152, 20);
			this.textLength.TabIndex = 22;
			this.textLength.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// panel
			// 
			this.panel.BackColor = System.Drawing.SystemColors.Window;
			this.panel.Location = new System.Drawing.Point(176, 12);
			this.panel.Name = "panel";
			this.panel.Size = new System.Drawing.Size(250, 260);
			this.panel.TabIndex = 29;
			this.panel.Paint += new System.Windows.Forms.PaintEventHandler(this.panel_Paint);
			// 
			// btnZoom
			// 
			this.btnZoom.Location = new System.Drawing.Point(92, 84);
			this.btnZoom.Name = "btnZoom";
			this.btnZoom.Size = new System.Drawing.Size(60, 24);
			this.btnZoom.TabIndex = 7;
			this.btnZoom.Text = "Zoom";
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(434, 279);
			this.Controls.Add(this.panel);
			this.Controls.Add(this.textArea);
			this.Controls.Add(this.textLength);
			this.Controls.Add(this.listView);
			this.Controls.Add(this.grpBoxPoint);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "FormMain";
			this.Text = "Figure";
			this.Load += new System.EventHandler(this.FormMain_Load);
			this.grpBoxPoint.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		void AddItemToListView(string s1, string s2, string s3)
		{
			ListViewItem item = new ListViewItem(s1);
			item.SubItems.Add(s2);
			item.SubItems.Add(s3);
			listView.Items.Add(item);
		}

		void UpdateProperties()
		{
			textLength.Text = "to do: Length = ";
			textArea.Text = "to do: Area = ";
		}

		void GetData()
		{
			int n = polygon.Count;
			// double x, y;

			listView.Items.Clear();
			// to do: get the coordinates of the figure points
			// AddItemToListView(string col1, string col2, string col3)

			for (int i = 0; i < n; i++)
			{
				char c = (char) (i + 65);
				AddItemToListView(c.ToString(), 
					String.Format("{0:f1}", polygon.GetPoint(i).X), 
					String.Format("{0:f1}", polygon.GetPoint(i).X));
			}
			UpdateProperties();
			panel.Invalidate();
		}

		private void editX_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (!Double.TryParse(editX.Text, NumberStyles.Float, NumberFormatInfo.CurrentInfo, out newX))
			{
				e.Cancel = true;
				MessageBox.Show("Please enter a number!");
			}
		}

		private void editY_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (!Double.TryParse(editY.Text, NumberStyles.Float, NumberFormatInfo.CurrentInfo, out newY))
			{
				e.Cancel = true;
				MessageBox.Show("Please enter a number!");
			}	
		}


		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			// to do: set newX and newY as new coordinates for the selected point
		}

		private void listView_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (listView.SelectedIndices.Count > 0)
			{
				index = listView.SelectedIndices[0];	// selected line number (0, 1, ...)
				btnUpdate.Enabled = true;
				newX = polygon.GetPoint(index).X;
				newY = polygon.GetPoint(index).X;
				editX.Text = String.Format("{0:f2}", newX);
				editY.Text = String.Format("{0:f2}", newY);
			}
			else
			{
				btnUpdate.Enabled = false;
			}		
		}

		private void panel_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			plot.PageSizeMM(200.0, 0.0);

			// x-axis
			plot.Xaxis(25.0, 25.0, 150.0, 0.0, 15.0, 2.0, "x");
			// y-axis
			plot.Yaxis(25.0, 25.0, 150.0, 0.0, 15.0, 2.0, "y");

			// user coordinates

			plot.Origin(25.0, 25.0);
			plot.XScale(10.0, 100.0);
			plot.YScale(10.0, 100.0);

			// to do: draw the figure

			int n = polygon.Count;
			plot.Move(polygon.GetPoint(n-1).X, polygon.GetPoint(n-1).Y);
			for (int i = 0; i < n; i++)
			{
				plot.Draw(polygon.GetPoint(i).X, polygon.GetPoint(i).Y);
			}
		}

		private void FormMain_Load(object sender, System.EventArgs e)
		{
			// create a plot object
			plot = new Plot(panel.CreateGraphics());

			// to do: create a figure object
			polygon = new Polygon();
			polygon.AddPoint(2.0, 3.0);
			polygon.AddPoint(10.0, 8.0);
			polygon.AddPoint(5.0, 10.0);

			GetData();
		}

	}
}
